@version 0.1
@warnings
@script modeler

ft=0;
//Edit
c1;
c2;
c3;
c4;
c5;
c6;
c7;
c8;

//Extrude



//Variables
radius = 1;
height_Y = 1;
turns = 1;
details = 20;
segments = 12;
phase = 0;
shake = 0;
flare = 0;

layer_spline = lyrfg();
layer_spiral = (layer_spline[1] + 1);
layer_save = (layer_spline[1] + 2);

main
{
	copy();
	lyrsetfg(layer_save);
	paste();
	lyrsetfg(layer_spline);
	
	interface();
}

interface
{
	reqbegin("SpiralSpline [0.1]");
	reqsize(250,250);
	
	
	c1 = ctlminislider("Radius",radius,1,100);
	c2 = ctlminislider("Heigth",height_Y,0,100);
	c3 = ctlminislider("Turns",turns,0,200);
	c4 = ctlminislider("Details",details,1,100);
	c5 = ctlminislider("Segments",segments,1,100);
	c6 = ctlminislider("Phase",phase,-100,100);
	c7 = ctlminislider("Shake",shake,-100,100);
	c8 = ctlminislider("Flare",flare,-100,100);
	
	if(ft==0)
	{
		general(1);
		ft=1;
	}
	
	ctlrefresh(c1,"general");
	ctlrefresh(c2,"general");
	ctlrefresh(c3,"general");
	ctlrefresh(c4,"general");
	ctlrefresh(c5,"general");
	ctlrefresh(c6,"general");
	ctlrefresh(c7,"general");
	ctlrefresh(c8,"general");
	
	
    return if !reqpost();
	
	reqend();
}

general: val
{
	delete();
	lyrsetfg(layer_save);
	copy();
	lyrsetfg(layer_spline);
	paste();
	
	spline_spiral_function(1);
	
}

spline_spiral_function: val
{
	selmode(USER);
	
	segments = getvalue(c5);
	height_Y = getvalue(c2);
	radius = getvalue(c1);
	turns = getvalue(c3);
	
	numPoint = pointcount();
	
	move(radius,0,0);
	
	lyrsetfg(layer_spiral);
	spiral(1);
	lyrsetfg(layer_spline);
	lyrsetbg(layer_spiral);
	
	min = numPoint;
	segments_total = (turns * segments);
	railextrude(segments_total,1,"o");
	
	lyrsetfg(layer_spiral);
	delete();
	
	lyrsetfg(layer_spline);
	
	max = pointcount();
	
	turnes = (max / min) - 1;
	
	start_point = min + 1;
	end_point = (min + min);
	
	for(i=1; i<=turnes; i++)
	{
		for(j=start_point; j<=end_point; j++)
		{
			selpoint(SET, POINTNDX, j);
		}
		
		pos_y = (height_Y*i)/(10*turnes);
		
		move(0,pos_y,0);
		
		selpoint(CLEAR);
		
		start_point += (min);
		end_point += (min);
	}
}

spiral: val
{

radius = getvalue(c1);
height_Y = getvalue(c2);
turns = getvalue(c3);
details = getvalue(c4);
phase = getvalue(c6);
shake = getvalue(c7);
flare = getvalue(c8);
	
delete();


editbegin();

	l = <0,0,0>;
	
	r = turns * details;
	
	for(x=0; x<=r; x++)
	{
		num = (x * 3.1415926536) / (details); 
		
			phase_a = (phase / 100);
			phase_b = -(phase / 100);
			
			shake_x = cos(x)*(shake/100);
		
			flare_XZ = (num*(flare/100));
		
			l.x = (cos(num)*(radius+phase_a+shake_x+flare_XZ));
			l.z = (sin(num)*(radius+phase_b+shake_x+flare_XZ));
		
			l.y = 0;
		
		num_point = (x + 1);
		p[num_point] = addpoint(l);
	}
	
	
	addcurve(p);
	
	
editend();	
}

toggleOn: value
{
   return(value);
}
